DROP TABLE TFC.TipusCens CASCADE CONSTRAINTS;

  CREATE TABLE TFC.TIPUSCENS 
(
IDTIPUSCENS           NUMBER            NOT NULL , 
DESCRIPCIO            VARCHAR2(100)     NOT NULL 
) ;
ALTER TABLE TFC.TIPUSCENS ADD CONSTRAINT PK_TIPUSCENS 
            PRIMARY KEY (IDTIPUSCENS) ;
 
-- -----------------------------------------------------------------------------
DROP TABLE TFC.TipusEstadistica CASCADE CONSTRAINTS;

  CREATE TABLE TFC.TIPUSESTADISTICA 
(
IDTIPUSE                  NUMBER 	NOT NULL , 
DESCRIPCIO                VARCHAR2(200) NOT NULL 
) ;
ALTER TABLE TFC.TIPUSESTADISTICA ADD CONSTRAINT PK_TIPUSESTADISTICA 
            PRIMARY KEY (IDTIPUSE) ;
 
-- -----------------------------------------------------------------------------

DROP TABLE TFC.CensEstatal CASCADE CONSTRAINTS;

  CREATE TABLE TFC.CENSESTATAL 
(
IDPAIS            NUMBER        	 	NOT NULL , 
IDTIPUSCENS       NUMBER        	 	NOT NULL , 
CODIPAIS          VARCHAR2(2)   	 	NOT NULL , 
NOM               VARCHAR2(50)  		NOT NULL ,
ACTIU		  NUMBER	DEFAULT 1	NOT NULL ,
DATABAIXA	  DATE					 

) ;
ALTER TABLE TFC.CENSESTATAL ADD CONSTRAINT PK_CENSESTATAL 
            PRIMARY KEY (IDPAIS, IDTIPUSCENS) ;
ALTER TABLE TFC.CENSESTATAL ADD CONSTRAINT FK_TIPUSCENSESTATAL 
            FOREIGN KEY (IDTIPUSCENS)
            REFERENCES TFC.TIPUSCENS (IDTIPUSCENS) ;
            
-- ----------------------------------------------------------------------------- 
DROP TABLE TFC.CensGlobal CASCADE CONSTRAINTS;

  CREATE TABLE TFC.CENSGLOBAL 
(
CODI              NUMBER      		 	NOT NULL , 
IDTIPUSCENS       NUMBER     		 	NOT NULL 

) ;

ALTER TABLE TFC.CENSGLOBAL ADD CONSTRAINT PK_CENSGLOBAL 
            PRIMARY KEY (CODI, IDTIPUSCENS) ;
ALTER TABLE TFC.CENSGLOBAL ADD CONSTRAINT FK_TIPUSCENSGLOBAL 
            FOREIGN KEY (IDTIPUSCENS)
            REFERENCES TFC.TIPUSCENS (IDTIPUSCENS) ;
 
-- -----------------------------------------------------------------------------
DROP TABLE TFC.CensLocal CASCADE CONSTRAINTS;

  CREATE TABLE TFC.CENSLOCAL 
(
IDLOCAL             NUMBER              		NOT NULL , 
IDTIPUSCENS         NUMBER              		NOT NULL , 
IDPAIS              VARCHAR2(2)              		NOT NULL , 
IDREGIO             NUMBER             			NOT NULL , 
NOM                 VARCHAR2(50)        		NOT NULL ,
ACTIU		    NUMBER	     DEFAULT 1		NOT NULL ,
DATABAIXA	    DATE					 

) ;
ALTER TABLE TFC.CENSLOCAL ADD CONSTRAINT PK_CENSLOCAL 
            PRIMARY KEY (IDLOCAL, IDTIPUSCENS) ;
ALTER TABLE TFC.CENSLOCAL ADD CONSTRAINT FK_TIPUSCENSLOCAL 
            FOREIGN KEY (IDTIPUSCENS)
            REFERENCES TFC.TIPUSCENS (IDTIPUSCENS) ;
-- -----------------------------------------------------------------------------
DROP TABLE TFC.CensRegional CASCADE CONSTRAINTS;

  CREATE TABLE TFC.CENSREGIONAL 
(
IDREGIO                 NUMBER          		NOT NULL , 
IDTIPUSCENS             NUMBER          		NOT NULL , 
IDPAIS                  VARCHAR(2)          		NOT NULL , 
NOM                     VARCHAR2(50)    		NOT NULL ,
ACTIU		  	NUMBER		DEFAULT 1	NOT NULL ,
DATABAIXA		DATE					 

) ;
ALTER TABLE TFC.CENSREGIONAL ADD CONSTRAINT PK_CENSREGIONAL 
            PRIMARY KEY (IDREGIO, IDTIPUSCENS) ;
 ALTER TABLE TFC.CENSREGIONAL ADD CONSTRAINT FK_TIPUSCENSREGIONAL 
            FOREIGN KEY (IDTIPUSCENS)
            REFERENCES TFC.TIPUSCENS (IDTIPUSCENS) ;
-- -----------------------------------------------------------------------------
DROP TABLE TFC.Ciutada CASCADE CONSTRAINTS;

  CREATE TABLE TFC.CIUTADA 
(
IDCIUTADA           NUMBER            		NOT NULL , 
CODICIUTADA	    VARCHAR2(11)      		NOT NULL ,	
DATANAIXEMENT       DATE	      		NOT NULL ,
NUMVOTSEMESOS	    NUMBER	   DEFAULT 0	NOT NULL ,
ACTIU		    NUMBER	   DEFAULT 1	NOT NULL ,
DATABAIXA	    DATE					 	
) ;
ALTER TABLE TFC.CIUTADA ADD CONSTRAINT PK_CIUTADA 
            PRIMARY KEY (IDCIUTADA) ;
 
-- -----------------------------------------------------------------------------
DROP TABLE TFC.Votacio CASCADE CONSTRAINTS;

  CREATE TABLE TFC.VOTACIO 
(
IDVOTACIO               NUMBER 				NOT NULL , 
TITOL                   VARCHAR2(50) 			NOT NULL , 
DESCRIPCIO              VARCHAR2(100) 			NOT NULL , 
DATAINICI               DATE 				NOT NULL , 
DATAFI                  DATE 				NOT NULL , 
DATAPUBLICACIO          DATE 				NOT NULL , 
PRESIDENT               NUMBER 				NOT NULL , 
WEB                     VARCHAR2(50)				 , 
ESTATVOTACIO            NUMBER 		DEFAULT 1	NOT NULL , 
NUMTOTALSCIUTADANS      NUMBER 		DEFAULT 0	NOT NULL 
) ;
ALTER TABLE TFC.VOTACIO ADD CONSTRAINT PK_VOTACIO 
            PRIMARY KEY (IDVOTACIO) ;
ALTER TABLE TFC.VOTACIO ADD CONSTRAINT FK_PRESIDENT 
            FOREIGN KEY (PRESIDENT)
            REFERENCES TFC.CIUTADA (IDCIUTADA) ;
 
-- -----------------------------------------------------------------------------

DROP TABLE TFC.Ambit CASCADE CONSTRAINTS;

CREATE TABLE TFC.AMBIT 
(
IDAMBIT          NUMBER NOT NULL, 
IDVOTACIO        NUMBER NOT NULL , 
CODICENS         NUMBER NOT NULL , 
IDTIPUSCENS      NUMBER NOT NULL 
) ;

ALTER TABLE TFC.AMBIT ADD CONSTRAINT PK_AMBIT 
            PRIMARY KEY (IDAMBIT);
ALTER TABLE TFC.AMBIT ADD CONSTRAINT FK_VOTACIOAMBIT 
            FOREIGN KEY (IDVOTACIO)
            REFERENCES TFC.VOTACIO (IDVOTACIO);
 
-- -----------------------------------------------------------------------------
DROP TABLE TFC.CensCiutadans CASCADE CONSTRAINTS;

  CREATE TABLE TFC.CENSCIUTADANS 
(
IDCENSCIUTADANS         NUMBER      			NOT NULL , 
IDCIUTADA               NUMBER      			NOT NULL , 
IDCODICENS              NUMBER      			NOT NULL , 
IDTIPUSCENS             NUMBER     			NOT NULL ,
ACTIU			NUMBER      DEFAULT 1		NOT NULL ,
DATABAIXA	 	DATE					 	 
) ;
ALTER TABLE TFC.CENSCIUTADANS ADD CONSTRAINT PK_CENSCIUTADANS 
            PRIMARY KEY (IDCENSCIUTADANS) ;
ALTER TABLE TFC.CENSCIUTADANS ADD CONSTRAINT FK_CENSCIUTADA 
            FOREIGN KEY (IDCIUTADA)
            REFERENCES TFC.CIUTADA (IDCIUTADA) ;

-- -----------------------------------------------------------------------------

DROP TABLE TFC.Est10 CASCADE CONSTRAINTS;

  CREATE TABLE TFC.EST10 
(
CODI                    NUMBER        NOT NULL , 
IDTIPUSE                NUMBER        NOT NULL , 
NUMMAXIMVOTACIONS       NUMBER        NOT NULL , 
CIUTADA                 NUMBER        NOT NULL , 
PAIS                    VARCHAR2(2)   NOT NULL 
) ;
ALTER TABLE TFC.EST10 ADD CONSTRAINT PK_EST10 
            PRIMARY KEY (CODI) ;
ALTER TABLE TFC.EST10 ADD CONSTRAINT FK_TIPUSE10 
            FOREIGN KEY (IDTIPUSE)
            REFERENCES TFC.TIPUSESTADISTICA (IDTIPUSE) ;

-- ----------------------------------------------------------------------------- 
DROP TABLE TFC.Est13 CASCADE CONSTRAINTS;

  CREATE TABLE TFC.EST13 
(
CODI                  NUMBER          NOT NULL , 
TIPUSE 	              NUMBER          NOT NULL , 
TIPUSCENS	      NUMBER	      NOT NULL ,
CODICENS              NUMBER          NOT NULL , 
ANNO                  NUMBER          NOT NULL , 
VALOR                 NUMBER          NOT NULL 
) ;
ALTER TABLE TFC.EST13 ADD CONSTRAINT PK_EST13 
            PRIMARY KEY (CODI) ;
ALTER TABLE TFC.EST13 ADD CONSTRAINT FK_TIPUSE13 
            FOREIGN KEY (TIPUSE)
            REFERENCES TFC.TIPUSESTADISTICA (IDTIPUSE) ;
 
-- -----------------------------------------------------------------------------
DROP TABLE TFC.Est46 CASCADE CONSTRAINTS;

  CREATE TABLE TFC.EST46 
(
CODI                NUMBER          NOT NULL , 
IDTIPUSE            NUMBER          NOT NULL , 
ANNO                NUMBER          NOT NULL , 
VALOR               NUMBER          NOT NULL ,
IDV		    NUMBER          NOT NULL
) ;
ALTER TABLE TFC.EST46 ADD CONSTRAINT PK_EST46 
            PRIMARY KEY (CODI) ;
ALTER TABLE TFC.EST46 ADD CONSTRAINT FK_TIPUSE46 
            FOREIGN KEY (IDTIPUSE)
            REFERENCES TFC.TIPUSESTADISTICA (IDTIPUSE) ;

-- -----------------------------------------------------------------------------
DROP TABLE TFC.Est79 CASCADE CONSTRAINTS;

  CREATE TABLE TFC.EST79 
(
CODI              NUMBER        NOT NULL , 
IDTIPUSE          NUMBER        NOT NULL , 
VOTACIO           NUMBER        NOT NULL ,
VALOR		  NUMBER	NOT NULL
) ;
ALTER TABLE TFC.EST79 ADD CONSTRAINT PK_EST79 
            PRIMARY KEY (CODI) ;
ALTER TABLE TFC.EST79 ADD CONSTRAINT FK_TIPUSE79 
            FOREIGN KEY (IDTIPUSE)
            REFERENCES TFC.TIPUSESTADISTICA (IDTIPUSE) ;
 
-- -----------------------------------------------------------------------------
DROP TABLE TFC.Logs CASCADE CONSTRAINTS;

  CREATE TABLE TFC.LOGS 
(
IDLOG                NUMBER                 NOT NULL , 
DATALOG              DATE                   NOT NULL , 
NOMPROCEDIMENT       VARCHAR2(200)          NOT NULL , 
PARAME               VARCHAR2(2000)         NOT NULL , 
PARAMS               VARCHAR2(2000)         NOT NULL 
) ;
ALTER TABLE TFC.LOGS ADD CONSTRAINT PK_LOGS 
      PRIMARY KEY (IDLOG) ;
 
-- -----------------------------------------------------------------------------

DROP TABLE TFC.OpcioVot CASCADE CONSTRAINTS;

  CREATE TABLE TFC.OPCIOVOT 
(
IDVOTACIO           NUMBER            NOT NULL , 
NUMOPCIO	    NUMBER	      NOT NULL, 
DESCRIPCIO          VARCHAR2(100)     NOT NULL 
) ;
ALTER TABLE TFC.OPCIOVOT ADD CONSTRAINT PK_OPCIOVOT 
            PRIMARY KEY (IDVOTACIO, NUMOPCIO) ;
ALTER TABLE TFC.OPCIOVOT ADD CONSTRAINT FK_VOTACIOOPCIOVOT 
            FOREIGN KEY (IDVOTACIO)
            REFERENCES TFC.VOTACIO (IDVOTACIO) ;
 
-- -----------------------------------------------------------------------------
DROP TABLE TFC.VotEmes CASCADE CONSTRAINTS;

  CREATE TABLE TFC.VOTEMES 
(
IDVOTACIO         NUMBER NOT NULL , 
NUMOPCIO          NUMBER NOT NULL , 
IDCIUTADA         NUMBER NOT NULL 
) ;
ALTER TABLE TFC.VOTEMES ADD CONSTRAINT PK_VOTEMES 
            PRIMARY KEY (IDVOTACIO, IDCIUTADA) ;
ALTER TABLE TFC.VOTEMES ADD CONSTRAINT FK_VOTEMESCIUTADA 
            FOREIGN KEY (IDCIUTADA)
            REFERENCES TFC.CIUTADA (IDCIUTADA) ;
ALTER TABLE TFC.VOTEMES ADD CONSTRAINT FK_VOTEMESOPCIO 
            FOREIGN KEY (IDVOTACIO, NUMOPCIO)
            REFERENCES TFC.OPCIOVOT (IDVOTACIO, NUMOPCIO) ;
-- -----------------------------------------------------------------------------
DROP TABLE TFC.OpcionsVotacioTancada CASCADE CONSTRAINTS;

  CREATE TABLE TFC.OPCIONSVOTACIOTANCADA 
(
IDOPVOTTANCADA		      NUMBER      NOT NULL , 
IDVOTACIO		      NUMBER	  NOT NULL ,
NUMOPCIO		      NUMBER	  NOT NULL , 
NUMVOTS                       NUMBER      NOT NULL , 
PARTICIPACIO	              NUMBER      NOT NULL 
) ;
ALTER TABLE TFC.OPCIONSVOTACIOTANCADA ADD CONSTRAINT PK_OPVOTTANCADA 
            PRIMARY KEY (IDVOTACIO, NUMOPCIO) ;
ALTER TABLE TFC.OPCIONSVOTACIOTANCADA ADD CONSTRAINT FK_OP_OPvOTTANC 
            FOREIGN KEY (IDVOTACIO, NUMOPCIO)
            REFERENCES TFC.OPCIOVOT (IDVOTACIO, NUMOPCIO) ;

-- -----------------------------------------------------------------------------

DROP TABLE TFC.VotacioTancada CASCADE CONSTRAINTS;

  CREATE TABLE TFC.VOTACIOTANCADA 
(
IDVOTACIOTANCADA              NUMBER      NOT NULL , 
NOMBREVOTANTS                 NUMBER      NOT NULL , 
IDVOTACIO                     NUMBER      NOT NULL , 
VOTSEMESOS                    NUMBER      NOT NULL , 
PPARTICIPACIO		      NUMBER      NOT NULL , 
OPCIOGUANYADORA               NUMBER      NOT NULL , 
POPGUANYADORA		      NUMBER      NOT NULL , 
OPMENYSVOTADA  	              NUMBER      NOT NULL , 
POPMENYSVOTADA		      NUMBER      NOT NULL 
) ;
ALTER TABLE TFC.VOTACIOTANCADA ADD CONSTRAINT PK_VOTACIOTANCADA 
            PRIMARY KEY (IDVOTACIOTANCADA) ;
ALTER TABLE TFC.VOTACIOTANCADA ADD CONSTRAINT FK_VTVOTACIO 
            FOREIGN KEY (IDVOTACIO)
            REFERENCES TFC.VOTACIO (IDVOTACIO) ;
ALTER TABLE TFC.VOTACIOTANCADA ADD CONSTRAINT FK_VTOGUANYADORA 
            FOREIGN KEY (IDVOTACIO, OPCIOGUANYADORA)
            REFERENCES TFC.OPCIONSVOTACIOTANCADA (IDVOTACIO, NUMOPCIO) ;
ALTER TABLE TFC.VOTACIOTANCADA ADD CONSTRAINT FK_VTPERDEDORA 
            FOREIGN KEY (IDVOTACIO, OPMENYSVOTADA)
            REFERENCES TFC.OPCIONSVOTACIOTANCADA (IDVOTACIO, NUMOPCIO) ;
 
-- -----------------------------------------------------------------------------

DROP TABLE TFC.VotacionsCiutada CASCADE CONSTRAINTS;

 CREATE TABLE TFC.VOTACIONSCIUTADA 
(
IDVOTACIO             NUMBER              		NOT NULL , 
IDCIUTADA             NUMBER              		NOT NULL , 
IDCODICENS            NUMBER              		NOT NULL , 
IDTIPUSCENS           NUMBER             		NOT NULL , 
PARTICIPACIO          NUMBER        DEFAULT 0		NOT NULL ,
ANNO		      NUMBER				NOT NULL ,
IDLOCALITAT	      NUMBER					  

) ;
ALTER TABLE TFC.VOTACIONSCIUTADA ADD CONSTRAINT PK_VOTACIONSCIUTADA 
            PRIMARY KEY (IDVOTACIO, IDCIUTADA) ;
ALTER TABLE TFC.VOTACIONSCIUTADA ADD CONSTRAINT FK_IDVOTACIO_VC 
            FOREIGN KEY (IDVOTACIO)
            REFERENCES TFC.VOTACIO (IDVOTACIO) ;
ALTER TABLE TFC.VOTACIONSCIUTADA ADD CONSTRAINT FK_IDCIUTADA_VC 
            FOREIGN KEY (IDCIUTADA)
            REFERENCES TFC.CIUTADA (IDCIUTADA) ;